clear, close all

disp 'Please open your 10x10 image at collimator in 90 degrees'
     [dFileName, dPathName] = uigetfile('*.dcm','Open image'); 
     filename = [dPathName dFileName];
     [Dose1 header frames SDD pixres] = LoadEpid(filename);
     a1=Dose1;
     
     [v g]=size(a1);
    
    px1= mean (a1(v/2-2:v/2+2,:)); %  Average profile in X direction
    Maxx1=max (px1);
    Minx1=min (px1);
    pxmean1=(Maxx1+Minx1)/2;
            
    py1= mean (a1(:,g/2-2:g/2+2)'); %  Average profile in Y direction
    Maxy1=max (py1);
    Miny1=min (py1);
    pymean1=(Maxy1+Miny1)/2;
    
    [X_1]= find (px1 >= pxmean1);         XX1  = X_1(1); XXend1 = X_1(end);
    [Y_1]= find (py1 >= pymean1);         YY1  = Y_1(1); YYend1 = Y_1(end);
    
    
    xL1 = [(XX1-2),(XX1-1),(XX1),(XX1+1)];              yL1 = px1(xL1);    ycL1= interp1(yL1,xL1,pxmean1,'cubic');  
    xR1 = [(XXend1-1),(XXend1),(XXend1+1),(XXend1+2)];  yR1 = px1(xR1);    ycR1= interp1(yR1,xR1,pxmean1,'cubic');  
    X1Center=mean([ycL1,ycR1]);
    
    yL1 = [(YY1-2),(YY1-1),(YY1),(YY1+1)];              yyL1 = py1(yL1);    yycL1= interp1(yyL1,yL1,pymean1,'cubic');  
    yR1 = [(YYend1-1),(YYend1),(YYend1+1),(YYend1+2)];  yyR1 = py1(yR1);    yycR1= interp1(yyR1,yR1,pymean1,'cubic');  
    Y1Center=mean([yycL1,yycR1]); 
    
    %%% ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
    %%% -------------------------------------------------------------------
    disp 'Please open your 10x10 image at collimator in 270 degrees'
     [dFileName, dPathName] = uigetfile('*.dcm','Open image'); 
     filename = [dPathName dFileName];
     [Dose1 header frames SDD pixres] = LoadEpid(filename);
     a2=Dose1;
     
     [t s]=size(a2);
    
    px2= mean (a2(t/2-2:t/2+2,:)); %  Average profile in X direction
    Maxx2=max (px2);
    Minx2=min (px2);
    pxmean2=(Maxx2+Minx2)/2;
            
    py2= mean (a2(:,s/2-2:s/2+2)'); %  Average profile in Y direction
    Maxy2=max (py2);
    Miny2=min (py2);
    pymean2=(Maxy2+Miny2)/2;
    
    [X_2]= find (px2 >= pxmean2);         XX2  = X_2(1); XXend2 = X_2(end);
    [Y_2]= find (py2 >= pymean2);         YY2  = Y_2(1); YYend2 = Y_2(end);
    
    
    xL2 = [(XX2-2),(XX2-1),(XX2),(XX2+1)];              yL2 = px2(xL2);    ycL2= interp1(yL2,xL2,pxmean2,'cubic');  
    xR2 = [(XXend2-1),(XXend2),(XXend2+1),(XXend2+2)];  yR2 = px2(xR2);    ycR2= interp1(yR2,xR2,pxmean2,'cubic');  
    X2Center=mean([ycL2,ycR2]);
    
    yL2 = [(YY2-2),(YY2-1),(YY2),(YY2+1)];              yyL2 = py2(yL2);    yycL2= interp1(yyL2,yL2,pymean2,'cubic');  
    yR2 = [(YYend2-1),(YYend2),(YYend2+1),(YYend2+2)];  yyR2 = py2(yR2);    yycR2= interp1(yyR2,yR2,pymean2,'cubic');  
    Y2Center=mean([yycL2,yycR2]); 
    
    X_Cax=mean([X1Center, X2Center])
    Y_Cax=mean([Y1Center, Y2Center])
    
    
    
    