% StarShot Algorithm
clear, close all

temp = 'Select all images with <Shift> and <Ctrl> keys';
[imagefile, dicompath, FILTERINDEX] = uigetfile('*.dcm',temp,'MultiSelect', 'on');
cd(dicompath);
if ~iscell(imagefile)
    imagefile = {imagefile}  ; %if only one field, convert the string to a cell
end
Nfields   = size(imagefile,2);
fprintf('\n Images selected:\n');
for f = 1 : Nfields;
        tempp = imagefile{f};
        fprintf('PI#%2d:  %s\n',f, tempp);
end
tic
TotalImages = Nfields + 2;

for f = 1 : Nfields
    %[filename, pathname] = uigetfile ('*.dcm','Load Images');
    filename = [dicompath imagefile{f}];
    [img header frames SDD pixres] = LoadEpid(filename);
    %[ p1(f), p2(f), R2(f), Q(:,f), y2(:,f), g] = StarShot_fun (img);
    [ p1(f), p2(f), R2(f), tet(f), g] = StarShot_fun (img,SDD);
    
      
    % gantry(f) = header.GantryAngle;
    %[CentX(f) CentY(f)] = FindCentreField(img);
    %[Xfild(f), Yfild(f), Xvalley(f), Yvalley(f),g] = mMLC_Sag_Fun(img);
    %[Xfild(f), Yfild(f), Xvalley(f), Yvalley(f),g] = Sag_Fun(img);
    %[Xfild(f), Yfild(f), Xvalley(f), Yvalley(f),YUf(f), YDf(f), XLf(f), XRf(f), g] = Sag_Fun_22(img);
    %[XFIELD(f), YFIELD(f), XB(f), YB(f),YUf(f), YDf(f), XLf(f), XRf(f), g] = Sag_Fun_22(img);
   
    %[X_s_centre(f), Y_s_centre(f)] = Iso_Center_Phantom(img); % for Phantom
    %EPID{f} = img;
end



 p1;
 p2;
% Q;
% y2;
% R2;
% g;
% f;
for i=1:f;
    if tet(i)< 0;
        tet(i)=tet(i)+180;
    end
end

% Number of triangles based on combination theory
N3= factorial(f)/(factorial(3)*factorial(f-3));

if g==512;
    res=0.392*2;
else
    res=0.392;
end

[R] = Core_fun (p1, p2, N3, f, SDD, res);

if g==512;
    res=0.392*2;
else
    res=0.392;
end
%R2'
R2_ave=mean(R2)
R2_SD=std(R2)
R_mm=R*res*100/SDD
toc
